// fengxf added begin: 20140326
// file: lib/common/plugin/watchMessage.js

 cordova.define("org.apache.cordova.watchMessage", function(require, exports, module) {

        var cordova = require('cordova'),
            exec = require('cordova/exec');

        function handlers() {
            return watchmessage.channels.messageupdated.numHandlers;
        }

        var Watchmessage = function() {

            this.channels = {
                messageupdated:cordova.addWindowEventHandler("messageupdated"),
            };
            for (var key in this.channels) {
                this.channels[key].onHasSubscribersChange = Watchmessage.onHasSubscribersChange;
            }
        };
		 /** 
		 * 一共5个参数 
		   第一个 :成功会掉 
		   第二个 :失败回调 
		   第三个 :将要调用的类的配置名字(在config.xml中配置 稍后在下面会讲解) 
		   第四个 :调用的方法名(一个类里可能有多个方法 靠这个参数区分) 
		   第五个 :传递的参数  以json的格式 
		 */  
        Watchmessage.onHasSubscribersChange = function() {
            if (this.numHandlers === 1 && handlers() === 1) {
                exec(watchmessage._messageupdate, watchmessage._error, "watchmessage", "messageupdated", []);
            } else if (handlers() === 0) {
                exec(null, null, "watchmessage", "stopwatch", []);
            }
        };

        Watchmessage.prototype._messageupdate = function(info) {
            if (info) {
                cordova.fireWindowEvent("messageupdated", info);
            }
        };

        Watchmessage.prototype._error = function(e) {
            console.log("Error initializing Watchmessage: " + e);
        };

        var watchmessage = new Watchmessage();

        module.exports = watchmessage;

    });
// fengxf added end: 20140326
